#! /usr/sbin/dtrace -s
#
# pragma D option quiet

syscall::read:entry
/execname != "dtrace"/
{
 self->tsr=timestamp;
 self->fdescr=arg0;
 self->rbuff=arg1;
}
syscall::read:return
/self->tsr/
{
 self->read = stringof(copyin(self->rbuff, arg0));
 printf("%s (%d) read %d bytes from descriptor: %d\n", execname, pid, arg0, self->fdescr);
 printf("   Read:%S\n", self->read);
 self->tsr=0;
 self->fdescr=0;
 self->rbuff=0;
}
syscall::write:entry
/execname != "dtrace"/
{
 self->tsw=timestamp;
 self->fdescw=arg0;
 self->written = stringof(copyin(arg1, arg2));
}
syscall::write:return
/self->tsw/
{
 printf("%s (%d) written %d bytes to descriptor: %d\n", execname, pid, arg0, self->fdescw);
 printf("  Written:%S\n", self->written);
 self->tsw=0;
 self->fdescw=0;
 self->written=0;
}
